const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const emailService = require('./email.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    emailService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    emailService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    emailService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    emailService.count()
        .then(result => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    emailService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    emailService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    emailService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
